/*

interstellar_help.js

Adds a ship that asks for your help in interstellar space.


Oolite
Copyright © 2004-2011 Giles C Williams and contributors

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA 02110-1301, USA.


interstellar_help.oxp
Copyright © 2008-2011 "Commander McLane"

This work is licensed under the Creative Commons
Attribution-Noncommercial-Share Alike 3.0 Unported License.

To view a copy of this license, visit
http://creativecommons.org/licenses/by-nc-sa/3.0/ or send a letter
to Creative Commons, 171 Second Street, Suite 300, San Francisco,
California, 94105, USA.

*/

"use strict";
this.name           = "interstellar_help";
this.author         = "Commander McLane";
this.copyright      = "© 2011 Commander McLane";
this.license		= "CC-by-nc-sa 3.0";
this.version        = "2.1";


this.shipWillEnterWitchspace = function(cause)
{
	if(system.isInterstellarSpace && this.interstellarHelp)
    {
        this.fuelUsed = system.info.distanceToSystem(System.infoForSystem(galaxyNumber, player.ship.targetSystem));
        missionVariables.interstellar_help_pay = (Math.round(this.fuelUsed * 2) * 10) + 50;
    }
	// next line is part of the substitution for playerJumpFailed
	if(system.isInterstellarSpace && this.playerCanJumpTimer.isRunning)
        this.playerCanJumpTimer.stop();
}

this.shipWillExitWitchspace = function()
{
	if(system.isInterstellarSpace && !this.interstellarHelp && Math.random() < 0.3) system.addShips("interstellar_help_trader", 1, [0, 0, 0], 15000);
}

this.playerJumpFailed = function(reason)
{
    if(system.isInterstellarSpace && reason == "insufficient fuel" && Math.random > 0.75 && system.countShipsWithRole("interstellar_helper") == 0)
	{
		system.addShips("interstellar_helper", 1, player.ship.position.add(Vector3D.randomDirection(27000)));
	}
}

/* the code below here is only a substitute as long as 'playerJumpFailed' doesn't work */

this.shipExitedWitchspace = function()
{
	if(system.isInterstellarSpace)
	{
		if(!this.playerCanJumpTimer) this.playerCanJumpTimer = new Timer(this, this.$checkPlayerFuel, 45, 45);
		else this.playerCanJumpTimer.start();
	}
}

this.$checkPlayerFuel = function()
{
	if(player.ship.fuel < 1 && system.countShipsWithRole("interstellar_helper") == 0)
		system.addShips("interstellar_helper", 1, player.ship.position.add(Vector3D.randomDirection(27000)));
}
